;; guile-gnome
;; Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>

;; This program is free software; you can redistribute it and/or    
;; modify it under the terms of the GNU General Public License as   
;; published by the Free Software Foundation; either version 2 of   
;; the License, or (at your option) any later version.              
;;                                                                  
;; This program is distributed in the hope that it will be useful,  
;; but WITHOUT ANY WARRANTY; without even the implied warranty of   
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
;; GNU General Public License for more details.                     
;;                                                                  
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, contact:
;;
;; Free Software Foundation           Voice:  +1-617-542-5942
;; 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
;; Boston, MA  02111-1307,  USA       gnu@gnu.org

;;; Commentary:
;;
;;g-wrap specification for libglade.
;;
;;; Code:

(define-module (gnome gtk gw-glade-spec)
  #:use-module (oop goops)
  #:use-module (g-wrap)
  #:use-module (g-wrap guile)
  #:use-module (gnome gtk gw-gtk-spec)
  #:use-module (gnome gobject defs-support)
  #:use-module (gnome gobject gw-spec-utils))

(define-class <glade-wrapset> (<gobject-wrapset-base>)
  #:language guile #:id 'gnome-glade)

(define-method (initialize (ws <glade-wrapset>) initargs)
  (next-method ws (cons #:module (cons '(gnome gtk gw-glade) initargs)))
  
  (depends-on! ws 'standard 'gnome-glib 'gnome-gobject 'gnome-gtk)

  (add-cs-global-declarator! ws
                             (lambda (wrapset)
                               '("#include <glade/glade.h>\n"
                                 "#include \"glade-support.h\"\n")))

  (add-cs-initializer!
   ws
   (lambda (wrapset status-var)
     '("glade_set_custom_handler (guile_glade_custom_handler, NULL);\n")))

  (load-defs ws "gnome/defs/libglade.defs"))
